/**
 *Contains the mail logic for the GuessTheNumber program
 */
public class Logic
{
    private Array a1, a2, a3, a4, a5, a6;
    private boolean t1, t2,t3,t4,t5,t6, invalidInput, run;
    private UserInput u;
    private int answer;

    /**
     * Creates a new Logic object and initializes 6 Array objects for the different number sequences as well as a
     * UserInput object for getting keyboard input from the user.
     */
    public Logic()
    {
        a1 = new Array(4,1);
        a2 = new Array(4,2);
        a3 = new Array(4,3);
        a4 = new Array(4,4);
        a5 = new Array(4,5);
        a6 = new Array(4,6);
        t1 = false;
        t2 = false;
        t3 = false;
        t4 = false;
        t5 = false;
        t6 = false;
        u = new UserInput();
        invalidInput = false;
        run = true;
    }

    /**
     * Displays instructions to the user
     * @throws InterruptedException for possible errors due to use of Thread.sleep for pauses.
     */
    public void intro() throws InterruptedException
    {
        System.out.println("This is a game where I will try to guess the number");
        System.out.println("you're thinking of");
        Thread.sleep(2000);
        System.out.println("Think of a whole number from 1 to 63");
        Thread.sleep(7000);
        System.out.println("I will show you 6 sets of numbers and you will answer");
        System.out.println("yes or no if your number is in that set.");
        System.out.println(" ");
    }

    /**
     * Displays sets of numbers to the user and gets input to determine if their number is displayed
     * in the current set of numbers.
     * @param type An integer to determine which Array object to display and which boolean value to update
     */
    public void showNumberSet(int type)
    {
        String inputString;
        switch (type)
        {
            case 1:
                a1.buildArray();
                a1.display();
                System.out.println("Is your number here?");
                System.out.println("Y/N: ");
                inputString = u.getUserInput();
                inputString = inputString.toLowerCase();
                if (inputString.equals("y"))
                    t1 = true;
                else if (inputString.equals("n"))
                    t1 = false;
                else
                    invalidInput = true;
                break;
            case 2:
                if (!invalidInput)
                {
                    a2.buildArray();
                    a2.display();
                    System.out.println("Is your number here?");
                    System.out.println("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.toLowerCase();
                    if (inputString.equals("y"))
                        t2 = true;
                    else if (inputString.equals("n"))
                        t2 = false;
                    else
                        invalidInput = true;
                }
                break;
            case 3:
                if (!invalidInput)
                {
                    a3.buildArray();
                    a3.display();
                    System.out.println("Is your number here?");
                    System.out.println("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.toLowerCase();
                    if (inputString.equals("y"))
                        t3 = true;
                    else if (inputString.equals("n"))
                        t3 = false;
                    else
                        invalidInput = true;
                }
                break;
            case 4:
                if (!invalidInput)
                {
                    a4.buildArray();
                    a4.display();
                    System.out.println("Is your number here?");
                    System.out.println("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.toLowerCase();
                    if (inputString.equals("y"))
                        t4 = true;
                    else if (inputString.equals("n"))
                        t4 = false;
                    else
                        invalidInput = true;
                }
                break;
            case 5:
                if (!invalidInput)
                {
                    a5.buildArray();
                    a5.display();
                    System.out.println("Is your number here?");
                    System.out.println("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.toLowerCase();
                    if (inputString.equals("y"))
                        t5 = true;
                    else if (inputString.equals("n"))
                        t5 = false;
                    else
                        invalidInput = true;
                }
                break;
            case 6:
                if (!invalidInput)
                {
                    a6.buildArray();
                    a6.display();
                    System.out.println("Is your number here?");
                    System.out.println("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.toLowerCase();
                    if (inputString.equals("y"))
                        t6 = true;
                    else if (inputString.equals("n"))
                        t6 = false;
                    else
                        invalidInput = true;
                }
                break;
        }
    }

   /* public void setOne()
    {
        String inputString;
        a1.buildArray();
        a1.display();
        System.out.println("Is your number here?");
        System.out.println("Y/N: ");
        inputString = u.getUserInput();
        inputString = inputString.toLowerCase();
        if (inputString.equals("y"))
            t1 = true;
        else if (inputString.equals("n"))
            t1 = false;
        else
            invalidInput = true;

    }

    public void setTwo()
    {
        if (!invalidInput)
        {
            String inputString;
            a2.buildArray();
            a2.display();
            System.out.println("Is your number here?");
            System.out.println("Y/N: ");
            inputString = u.getUserInput();
            inputString = inputString.toLowerCase();
            if (inputString.equals("y"))
                t2 = true;
            else if (inputString.equals("n"))
                t2 = false;
            else
                invalidInput = true;
        }
    }

    public void setThree()
    {
        if (!invalidInput)
        {
            String inputString;
            a3.buildArray();
            a3.display();
            System.out.println("Is your number here?");
            System.out.println("Y/N: ");
            inputString = u.getUserInput();
            inputString = inputString.toLowerCase();
            if (inputString.equals("y"))
                t3 = true;
            else if (inputString.equals("n"))
                t3 = false;
            else
                invalidInput = true;
        }
    }

    public void setFour()
    {
        if (!invalidInput)
        {
            String inputString;
            a4.buildArray();
            a4.display();
            System.out.println("Is your number here?");
            System.out.println("Y/N: ");
            inputString = u.getUserInput();
            inputString = inputString.toLowerCase();
            if (inputString.equals("y"))
                t4 = true;
            else if (inputString.equals("n"))
                t4 = false;
            else
                invalidInput = true;
        }
    }

    public void setFive()
    {
        if (!invalidInput)
        {
            String inputString;
            a5.buildArray();
            a5.display();
            System.out.println("Is your number here?");
            System.out.println("Y/N: ");
            inputString = u.getUserInput();
            inputString = inputString.toLowerCase();
            if (inputString.equals("y"))
                t5 = true;
            else if (inputString.equals("n"))
                t5 = false;
            else
                invalidInput = true;
        }
    }

    public void setSix()
    {
        if (!invalidInput)
        {
            String inputString;
            a6.buildArray();
            a6.display();
            System.out.println("Is your number here?");
            System.out.println("Y/N: ");
            inputString = u.getUserInput();
            inputString = inputString.toLowerCase();
            if (inputString.equals("y"))
                t6 = true;
            else if (inputString.equals("n"))
                t6 = false;
            else
                invalidInput = true;
        }

    }*/

    public void calculate()
    {
        if (!invalidInput)
        {
            if (t1)
                answer += 1;
            if (t2)
                answer += 2;
            if (t3)
                answer += 4;
            if (t4)
                answer += 8;
            if (t5)
                answer += 16;
            if (t6)
                answer += 32;
        }
    }

    public void displayResult() throws InterruptedException
    {
        if (invalidInput)
            System.out.println("ERROR: Invalid input detected");
        else if (answer < 1)
            System.out.println("ERROR: Your number is less than 1 or greater than 63.");
        else
            System.out.println("your number is " + answer);
        Thread.sleep(5000);
    }

    public void runAgain()
    {
        String input;
        System.out.println("Would you like to run this again?");
        System.out.println("Y/N: ");
        input = u.getUserInput().toLowerCase();
        if (input.equals("y"))
            run = true;
        else if (input.equals("n"))
            run = false;
        else
        {
            System.out.println("ERROR: Invalid input detected.");
            System.exit(0);
        }
    }

    public boolean getRunAgain()
    {
        return run;
    }


}
